package GUI;

import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JComboBox;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JTextField;

import Application.Converter;
import Application.CurrencyManager;

import java.util.Observable;
import java.util.Observer;

import javax.swing.JLabel;

import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormSpecs;
import com.jgoodies.forms.layout.RowSpec;

import java.awt.Rectangle;
import java.awt.Color;

@SuppressWarnings("serial")
public class MainFrame extends JFrame implements Observer {
	
	/**
	 * 
	 * @param s
	 * @param c
	 */
	public MainFrame(String s) {
		super(s);
		setBounds(new Rectangle(30, 30, 400, 200));
	    setLocationRelativeTo(null);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		
		mainconv = new Converter();
		mainconv.addObserver(this);
		currencies = new CurrencyManager();
		currencies.addObserver(this);
				
		getContentPane().setLayout(new FormLayout(new ColumnSpec[] {
				FormSpecs.RELATED_GAP_COLSPEC,
				ColumnSpec.decode("130px"),
				FormSpecs.LABEL_COMPONENT_GAP_COLSPEC,
				ColumnSpec.decode("130px"),
				FormSpecs.LABEL_COMPONENT_GAP_COLSPEC,
				ColumnSpec.decode("119px"),},
			new RowSpec[] {
				RowSpec.decode("33px"),
				RowSpec.decode("16px"),
				FormSpecs.RELATED_GAP_ROWSPEC,
				FormSpecs.DEFAULT_ROWSPEC,
				FormSpecs.UNRELATED_GAP_ROWSPEC,
				RowSpec.decode("25px"),
				FormSpecs.UNRELATED_GAP_ROWSPEC,
				RowSpec.decode("24px"),}));
		
		comboBox = new JComboBox<String>();
		comboBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				inAmount.setText("");
				outAmount.setText("");
			}
		});
		
		JButton btnNewButton = new JButton("Convert EUR");
		
		lblEur = new JLabel("EUR (€)");
		getContentPane().add(lblEur, "2, 4, left, default");
		getContentPane().add(comboBox, "4, 4, fill, fill");
		
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				handleButtonPressed(e.getSource());
			}
		});
		
		getContentPane().add(btnNewButton, "6, 4, left, fill");
		
		JLabel lblFrom = new JLabel("From");
		getContentPane().add(lblFrom, "2, 2, left, top");
		
		JLabel lblTo = new JLabel("To");
		getContentPane().add(lblTo, "4, 2, left, top");
		
		inAmount = new JTextField();
		getContentPane().add(inAmount, "2, 6, fill, fill");
		inAmount.setColumns(10);
		
		outAmount = new JTextField();
		outAmount.setEditable(false);
		getContentPane().add(outAmount, "4, 6, fill, fill");
		outAmount.setColumns(10);
		
		statustext = new JLabel("Status: OK");
		statustext.setForeground(Color.RED);
		getContentPane().add(statustext, "2, 8, 5, 1, right, bottom");	
		Thread t2 = new Thread(currencies);
		t2.start();
		setVisible(true);
	}

	public void handleButtonPressed(Object j) {
		try{
		String curr = comboBox.getItemAt(comboBox.getSelectedIndex());
		float rate = currencies.getCurrencyList().get(curr);
		mainconv.setInput(Float.parseFloat(inAmount.getText()), rate);
		Thread t = new Thread(mainconv);
		t.start();
		System.out.println("tread started");
		}
		catch(NullPointerException e){
			statustext.setText("no number given");
		}
		catch(NumberFormatException e){
			statustext.setText("no valid number given");
		}
		
	}

	
	public float getInput(){
		return Float.parseFloat(outAmount.getText());
	}
	private JComboBox<String> comboBox;
	private JTextField outAmount;
	private JTextField inAmount;
	private Converter mainconv;
	private JLabel lblEur;
	private JLabel statustext;
	private CurrencyManager currencies;
	@Override
	public void update(Observable o, Object arg) {
		
		System.out.println("i am notified");
		if (o.getClass() == Converter.class)
			statustext.setText("calculation done");
		outAmount.setText(String.valueOf(mainconv.getResult()));
		
		if (o.getClass() == CurrencyManager.class){
			System.out.println("i am updating the view");
			for (String key : currencies.getCurrencyList().keySet()) {    
				comboBox.addItem(key);
			}
		}
		
	}
}